{---------------------------------------------------------------------------}
{                                                                           }
{                               R O S W I T H A                             }
{                                                                           }
{                      Computergrafik 2/3 - Laborbung                      }
{                                                                           }
{---------------------------------------------------------------------------}
{                                                                           }
{ Datei    : palette.pas                                                    }
{ Autor    : Markus Halla                                                   }
{                                                                           }
{ Funktion : Liest die Farbwerte aus einer 256-Farben BMP-Datei aus und     }
{            erstellt daraus eine Textdatei.                                }
{            Weiters wird fr jede Farbe die passende abgedunkelte Farbe    }
{            gesucht und ebenfalls in die Datei geschrieben                 }
{                                                                           }
{---------------------------------------------------------------------------}
PROGRAM Palette;

USES Crt;

VAR r, g, b: ARRAY[0..255] of BYTE;

FUNCTION findColor(wr, wg, wb: BYTE): BYTE;

VAR nrBest, diffBest: INTEGER;
    diff: INTEGER;
    i: INTEGER;

BEGIN
    diffBest := 255 * 3 + 1;

    FOR i := 0 TO 255 DO BEGIN
        diff := abs(wr - r[i]) + abs(wg - g[i]) + abs(wb - b[i]);

        IF (diff < diffBest) THEN BEGIN
            diffBest := diff;
            nrBest   := i;
        END;
    END;

    findColor := nrBest;
END;

VAR bild: FILE OF BYTE;
    farben: TEXT;
    bmpName, defName: STRING;
    i, anzahl: INTEGER;
    j, jInc, jEnd: DOUBLE;
    w: BYTE;

BEGIN
    clrscr;
    writeln('Palettenerstellung fr Roswitha');
    writeln;
    writeln('V 1.1 (C) Markus Halla 1999');
    writeln;
    write('Name der BMP-Datei: ');
    readln(bmpName);
    write('Name der Definitionsdatei: ');
    readln(defName);
    write('Anzahl der Intensittsstufen (10): ');
    readln(anzahl);
    write('Unter Grenze der Intensitt (0.1): ');
    readln(jEnd);

    assign(bild, bmpName);
    reset(bild);

    assign(farben, defName);
    rewrite(farben);

    FOR i := 1 TO 54 DO
        read(bild, w);

    FOR i := 0 TO 255 DO BEGIN
        read(bild, b[i], g[i], r[i], w);
        writeln(farben, r[i], ' ', g[i], ' ', b[i]);
    END;

    jInc := (1.0 - jEnd) / (anzahl - 1);

    FOR i := 0 TO 255 DO BEGIN
        j := 1.0;
        REPEAT
            write(farben, findColor(round(r[i] * j), round(g[i] * j), round(b[i] * j)), ' ');
            j := j - jInc;
        UNTIL (j < jEnd);

        writeln(farben);
    END;

    close(farben);
    close(bild);
END.
